function [] = stop_execution()
  global('model_input');
  global('model_output');
  global('out_variables');
  global('n_run');
  global('N_RUNS');
  global('ui_controls');
  
  N_RUNS = n_run;
  log_text("<B>Simulation stopped at run "+sprintf("%d", N_RUNS) + ".</B>",1,1);
      
  for i=1:1:out_variables(ID_OUTVAR_COUNT)  // save valid output variables       
    if (out_variables(ID_OUTVAR_TYPE)(i) == "scalar")
       model_output(i) = model_output(i)(1:N_RUNS);            
    end
    if (out_variables(ID_OUTVAR_TYPE) == "vector")
            
    end                      
  end
      
  for i=1:1:in_variables_statistics(ID_INVAR_COUNT)  // save valid input variables       
    model_input(i) = model_input(i)(1:N_RUNS);            
  end
      
  try
    xx = ui_controls(ID_WINDOW_LIST)(ID_PLOT_WINDOW);
    fill_variable_lists();
  catch
    ui_controls(ID_B_PLOT_MAIN).enable= "on";
  end      
  
  montesci_logfile_info("Monte Carlo simulation done.");
  progress_bar_per(100);
      
  log_text("Cleaning up after runs and preparing outputs...", 1, 1);  
  post_all_runs(N_RUNS);
  log_text("", 1, 1);
  log_text("<B>Monte Carlo simulation done, ready to plot.</B>", 1, 1);
  log_text("", 1, 1);
  
  ui_controls(ID_B_RUN).enable= "on";
  ui_controls(ID_B_RUN).String= "Run Simulation";
  ui_controls(ID_B_SAVE).enable= "on";
  ui_controls(ID_B_LOAD).enable= "on";
  progress_bar_per(100);
  
  try
    xx = ui_controls(ID_WINDOW_LIST)(ID_VAR_EXPLORER);
    fill_values(-1);    
  catch    
  end
   
endfunction

function [] = abort_execution()
    global('ui_controls');
    ui_controls(ID_B_RUN).enable= "on";
    ui_controls(ID_B_SAVE).enable= "off";
    ui_controls(ID_B_LOAD).enable= "on";
    ui_controls(ID_B_PLOT_MAIN).enable= "off";
    abort;
endfunction

function [] = pause_execution()
    global('ui_controls');
    global('n_runs');
    ui_controls(ID_B_RUN).enable= "off";
    ui_controls(ID_B_PAUSE).enable= "on";
    ui_controls(ID_B_PAUSE).String= "Resume Simulation";
    ui_controls(ID_B_PAUSE).Callback= "resume_execution()";
    ui_controls(ID_B_STOP).enable= "on";
    ui_controls(ID_B_PLOT_MAIN).enable= "on";
    post_all_runs(n_runs-1);
    log_text("Paused simulation runs.",1,1)
    pause;
endfunction

function [] = resume_execution()
    global('ui_controls');
    log_text("Resuming simulation runs...",1,1)
    ui_controls(ID_B_RUN).enable= "off";
    ui_controls(ID_B_PAUSE).enable= "on";
    ui_controls(ID_B_PAUSE).String= "Pause Simulation";
    ui_controls(ID_B_PAUSE).Callback= "pause_execution()";
    ui_controls(ID_B_STOP).enable= "on";
    ui_controls(ID_B_PLOT_MAIN).enable= "off";
    resume;
endfunction

