

ID_XYFKT_WINDOW = 201;
ID_PM_FIT_SELECT = 202;
ID_B_FIT_SAVE = 203;
ID_B_FIT_CANCEL = 204;
ID_B_FIT_CHECK = 205;
ID_ED_FIT_FKT = 206;
ID_ED_FIT_FKT_NAME = 207;
ID_ED_FIT_FKT_START = 209;
ID_T_FIT_INFO = 210;
ID_B_FIT_DELETE = 211;

function [] = create_xyfitfkt_gui()
  global('ui_controls');

  gui_main = figure(ID_XYFKT_WINDOW);
  gui_fit_functions=gcf();
  ui_controls(ID_WINDOW_LIST)(ID_XYFKT_WINDOW) = gui_fit_functions;
  gui_main.position = [20 20 600 220];
  sleep(200);
  gui_main.figure_name = "XY Fit function editor";
  gui_main.background = gui_color_bg;
  
  toolbar(ID_XYFKT_WINDOW, 'off');
  
  delmenu(ID_XYFKT_WINDOW, 'File');
  delmenu(ID_XYFKT_WINDOW, 'Edit');
  delmenu(ID_XYFKT_WINDOW, 'Tools');
  delmenu(ID_XYFKT_WINDOW, '?');
  
  ui_controls(ID_PM_FIT_SELECT) = uicontrol(gui_fit_functions, 'style', 'popupmenu', 'position', [20 220 270 28],'Callback','fill_fit_fkts_pm()');
  ui_controls(ID_PM_FIT_SELECT).Value = 1;
  fill_fit_fkts_names();
  
  ui_controls(ID_ED_FIT_FKT_NAME) = uicontrol(gui_fit_functions, 'style', 'edit', 'position', [310 220 270 28], 'String', "enter name here");
  
  pmstr = "y = c(1) * x";
  ui_controls(ID_ED_FIT_FKT) = uicontrol(gui_fit_functions, 'style', 'edit', 'position', [20 180 460 28], 'String', pmstr);
  
  ui_controls(ID_ED_FIT_FKT_START) = uicontrol(gui_fit_functions, 'style', 'edit', 'position', [500 180 80 28], 'String', "start values");
    
  pmstr = "<HTML><B>&nbsp Fit Function definition</B>";
  pmstr = pmstr + "<BR>&nbsp Syntax y = f{x, c}";
  pmstr = pmstr + "<BR>&nbsp c is the parameter vector to be fit, length(c) &lt 10, c0 is the start value vector, separate values with comma.";
  pmstr = pmstr + "<BR>&nbsp x is the input vector selected in the plot GUI, length of x is ""xy_fit_fkt_max_points"" or N_RUNS,";
  pmstr = pmstr + "<BR>&nbsp &nbsp &nbsp &nbsp  whichever is smaller. Find ""xy_fit_fkt_max_points"" (default: 100) in ""montesci.conf"""
  pmstr = pmstr + "<BR>&nbsp f{...} must return a vector of the same length as x";
    
  ui_controls(ID_T_FIT_INFO) = uicontrol(gui_fit_functions, 'style', 'text', 'position', [20 65 560 100], 'String', pmstr);
  ui_controls(ID_T_FIT_INFO).BackgroundColor =  gui_plot_input_bg;
  
  
  ui_controls(ID_B_FIT_SAVE) = uicontrol(gui_fit_functions, 'style', 'pushbutton', 'position', [470 20 110 28], 'String', "Save", 'Callback', 'save_fit_fkt()');
  ui_controls(ID_B_FIT_SAVE).Enable = "off";
  ui_controls(ID_B_FIT_CHECK) = uicontrol(gui_fit_functions, 'style', 'pushbutton', 'position', [340 20 110 28], 'String', "Check", 'Callback', "check_fit_fkt()");
  ui_controls(ID_B_FIT_DELETE) = uicontrol(gui_fit_functions, 'style', 'pushbutton', 'position', [20 20 110 28], 'String', "Delete", 'Callback','delete_fit_fkt()');
  ui_controls(ID_B_FIT_DELETE).Enable = "off";
  
  fill_fit_fkts_pm();
  
endfunction


function [] = fill_fit_fkts_names()
  global("ui_controls");
  global("fit_functions");
  pmstr = "";
  for i=1:1:length(fit_functions)
    pmstr = pmstr+"|"+ fit_functions(i)(3);
  end;
  ui_controls(ID_PM_FIT_SELECT).String = pmstr;
endfunction


function [] = fill_fit_fkts_pm()
  global('ui_controls');
  global("fit_functions");
  
  ui_controls(ID_ED_FIT_FKT).String = fit_functions(ui_controls(ID_PM_FIT_SELECT).Value)(1); 
  if (ui_controls(ID_PM_FIT_SELECT).Value ~= 1)
    ui_controls(ID_ED_FIT_FKT_NAME).String = fit_functions(ui_controls(ID_PM_FIT_SELECT).Value)(3);
  else
    ui_controls(ID_ED_FIT_FKT_NAME).String="Enter name here";
  end
  ui_controls(ID_ED_FIT_FKT_START).String = string(fit_functions(ui_controls(ID_PM_FIT_SELECT).Value)(2));
  
  if (ui_controls(ID_PM_FIT_SELECT).Value==1) | (ui_controls(ID_PM_FIT_SELECT).Value>4) 
    ui_controls(ID_B_FIT_SAVE).Enable = "on";
  else
    ui_controls(ID_B_FIT_SAVE).Enable = "off";
  end  
  
  if ( (ui_controls(ID_PM_FIT_SELECT).Value ~= 1) & (fit_functions(ui_controls(ID_PM_FIT_SELECT).Value)(4)~="locked") ) // mask delete button
    ui_controls(ID_B_FIT_DELETE).Enable = "on";
  else
    ui_controls(ID_B_FIT_DELETE).Enable = "off";
  end
endfunction


function error_f = check_fit_fkt()
  global('ui_controls');
  global("fit_functions");
  
   
  s_exec = "c = [" + ui_controls(ID_ED_FIT_FKT_START).String + "]''";
  
  err = execstr(s_exec, 'errcatch');
    
  if (err~=0)
    messagebox("Error reading start values", "Error", "error", ["Continue"], "modal")
    error_f = 1;
    return;
  end
  
   
  x=0.5:1e-4:0.51;
   
  s_exec =  ui_controls(ID_ED_FIT_FKT).String;
  try
    execstr(s_exec);
  catch
    messagebox("Error evaluating function f(x, c0), x=0.5...0.51, This may be okay if there is a singularity in this interval.", "Error", "error", ["Continue"], "modal")
    error_f = 2;
    return;    
  end
 
  if (length(y) ~= length(x))
    messagebox("Function does not return a proper sized vector", "Error", "error", ["Continue"], "modal")
    error_f = 3;
    return; 
  end 
  
  messagebox("The function seems to be okay.", ["Continue"], "modal") 
  error_f = 0;
    
endfunction

function [] = delete_fit_fkt()
  global('ui_controls');
  global("fit_functions");
  global("model_fit_fkt");
  
  ans = messagebox("Delete """+ fit_functions( ui_controls(ID_PM_FIT_SELECT).Value)(3) + """ ?", "modal", "info", ["Yes" "No"])
  if (ans ==1)
    fit_functions(ui_controls(ID_PM_FIT_SELECT).Value) = null();
    fill_fit_fkts_names();
    ui_controls(ID_PM_FIT_SELECT).Value = 1;    
    ui_controls(ID_B_FIT_DELETE).Enable = "off";
    try
      save(model_fit_fkt, fit_functions);
    catch
      messagebox(["Error saving fit functions to file, check write permission on """+ model_fit_fkt+"""." "Deletion is only temporary now"],["Continue"], "modal")
    end     
    fill_plot_fit_fkts();
  end
  
  
endfunction

function [] = save_fit_fkt()
  global('ui_controls');
  global("fit_functions");
  global("model_fit_fkt");
  
  ex = 0;
  for (i=1:1:length(fit_functions)) // check if name already exists
    if (fit_functions(i)(3) == ui_controls(ID_ED_FIT_FKT_NAME).String) ex = i; end;
  end
  
  if (ex~=0)
    ans = messagebox("Function with this name already exists, overwrite?", "modal", "info", ["Yes" "No"])
    if (ans == 2) return; end; // do not save
    ind = ex;                  // save to existing function
  else
    ind = length(fit_functions)+1;  // append to list
  end;
  
  ff1 = list(0);
  ff1(1) = ui_controls(ID_ED_FIT_FKT).String;
  ff1(2) = ui_controls(ID_ED_FIT_FKT_START).String;
  ff1(3) = ui_controls(ID_ED_FIT_FKT_NAME).String;
  ff1(4) = "";
  
  try
    if (fit_functions(ind)(4) == "locked")
      messagebox("This function cannot be overwritten, use another name.", "Error", "error", ["Continue"], "modal")
      return;
    end
  catch
  end
  
  fit_functions(ind) = ff1;
  fill_fit_fkts_names();
  ui_controls(ID_PM_FIT_SELECT).Value = ind;
  ui_controls(ID_B_FIT_DELETE).Enable = "on";
  try
    save(model_fit_fkt, fit_functions);
    messagebox(["Saved fit functions to "+model_fit_fkt ],["Continue"], "modal")
  catch
    messagebox(["Error saving fit function to file, check write permission on """+ model_fit_fkt+"""." "The function will not be available after restarting MonteSci"],["Continue"], "modal")
  end
  fill_plot_fit_fkts();
  
endfunction
