ID_MAIN_WINDOW = 1;
ID_LOG_WINDOW = 1;
ID_LOG_WINDOW_SLIDER = 90;
ID_LOGTEXT = 100;
ID_LOGTEXT_POS = 101;
ID_B_PLOT_MAIN = 2;
ID_B_RUN = 3;
ID_B_PAUSE = 4;
ID_B_STOP = 5;
ID_B_SETUP = 6;
ID_B_PROGRESS = 7;
ID_B_SAVE = 10;
ID_B_LOAD = 11;

ID_ME_FILE = 20;
ID_ME_EDIT = 21;
ID_ME_RUN = 22;
ID_ME_VIEW = 23;
ID_ME_HELP = 24;

ID_ME_FILE_CREATE = 30;
ID_ME_FILE_OPEN = 31;
ID_ME_FILE_OPENDEMO = 32;
ID_ME_FILE_OPENDEMO_SC = 33;
ID_ME_FILE_OPENDEMO_VE = 34;
ID_ME_FILE_OPENDEMO_SP = 35;
ID_ME_FILE_LOAD_SIM = 36;
ID_ME_FILE_SAVE_SIM = 37;
ID_ME_FILE_OPEN_RECENT = 38;
ID_ME_FILE_OPEN_RECENT1 = 39;
ID_ME_FILE_OPEN_RECENT2 = 40;
ID_ME_FILE_OPEN_RECENT3 = 41;
ID_ME_FILE_OPEN_RECENT4 = 42;
ID_ME_FILE_OPEN_RECENT5 = 43;
ID_ME_FILE_OPEN_RECENT6 = 44;
ID_ME_FILE_PREFS = 45;
ID_ME_FILE_EXIT = 49;
ID_ME_EDIT = 50;
ID_ME_EDIT_MODEL = 51;
ID_ME_EDIT_MODEL_CONF = 52;
ID_ME_EDIT_MODEL_PRE = 53;
ID_ME_EDIT_INVAR = 54;
ID_ME_EDIT_OUTVAR = 55;
ID_ME_RUN = 60;
ID_ME_RUN_SIM = 61;
ID_ME_RUN_SWEEP = 62;
ID_ME_VIEW = 70;
ID_ME_VIEW_PLOT = 71;
ID_ME_VIEW_VAR = 72;
ID_ME_VIEW_LOG = 73;
ID_ME_HELP = 80;
ID_ME_HELP_ABOUT = 81;
ID_ME_HELP_HELP = 82;

ID_PLOT_LIST = 570;
ID_WINDOW_LIST = 571;


ui_controls = list(1);
global('ui_controls');
ui_controls(ID_PLOT_LIST) = list(1);
ui_controls(ID_PLOT_LIST)(1) = null();
ui_controls(ID_WINDOW_LIST) = list(1);
ui_controls(ID_WINDOW_LIST)(1) = null();


function [] = montesci_about()
  select = messagebox("<HTML> <B>MonteSci</B> - Monte carlo Simulator for Scilab.<BR> Rev: "+ montesci_version+"<BR>ka_eins, 01/2010</HTML>", "", "", ["Continue"; "License"], "modal");
  if (select==2) editor(montesci_root+"/license.txt"); end
endfunction

function [] = montesci_help()
  messagebox("<HTML> <BODY> Help can be found on the MonteSci webpage.<BR> <a href=http://www.drivehq.com/web/ka_eins/montesci> www.drivehq.com/web/ka_eins/montesci </a> </BODY></HTML>", "", "", ["Continue"], "modal");
endfunction

function [] = open_model_files()
  global("sim_conf");
  try  
    exec(model_dir + sim_conf);
  catch
    error_log_text("201: model.conf could not be executed correctly.");
    return;
  end 
  global("model_exec");  
  sleep(200); 
  if (editor_exec == "")  
    editor(model_exec);    
  else
    unix_g(editor_exec + " " + model_exec + " &");
  end
  for i=1:1:size(model_files_editor,1)
    sleep(100)
    if (editor_exec == "")
      editor(model_dir + model_files_editor(i));
    else
      unix_g(editor_exec + " " + model_dir + model_files_editor(i) + " &");
    end
  end
endfunction

function gui_main = create_montesci_gui()

  global('ui_controls');

  gui_main = figure(ID_MAIN_WINDOW);
  a=gcf();
  
  a.event_handler = 'close_montesci_handler' ;
  a.event_handler_enable = "on" ;
  
  ui_controls(ID_WINDOW_LIST)(ID_MAIN_WINDOW) = a;
  
  gui_main.position = [20 20 590 630];
  gui_main.figure_name = "MonteSci "+montesci_version;
  sleep(200);
  gui_main.background = gui_color_bg; 
  
  toolbar(ID_MAIN_WINDOW, 'off'),
  
  delmenu(ID_MAIN_WINDOW, 'File');
  delmenu(ID_MAIN_WINDOW, 'Edit');
  delmenu(ID_MAIN_WINDOW, 'Tools');
  delmenu(ID_MAIN_WINDOW, '?');
  
  ui_controls(ID_ME_FILE) = uimenu("Parent", gui_main, "Label", gettext("File")); 
  
  ui_controls(ID_ME_FILE_CREATE) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("New"), "Callback", "create_new_sim_gui()");
  ui_controls(ID_ME_FILE_OPEN) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Open"), "Callback", "open_sim_directory()");
  
  ui_controls(ID_ME_FILE_OPEN_RECENT) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Open recent"));
  ui_controls(ID_ME_FILE_OPEN_RECENT1) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 1"));
  ui_controls(ID_ME_FILE_OPEN_RECENT2) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 2"));
  ui_controls(ID_ME_FILE_OPEN_RECENT3) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 3"));
  ui_controls(ID_ME_FILE_OPEN_RECENT4) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 4"));
  ui_controls(ID_ME_FILE_OPEN_RECENT5) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 5"));
  ui_controls(ID_ME_FILE_OPEN_RECENT6) = uimenu("Parent", ui_controls(ID_ME_FILE_OPEN_RECENT), "Label", gettext("Recent 6"));
  
  ui_controls(ID_ME_FILE_OPENDEMO) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Open demo"));
  ui_controls(ID_ME_FILE_OPENDEMO_SC) = uimenu("Parent", ui_controls(ID_ME_FILE_OPENDEMO), "Label", gettext("Scalar demo"), "Callback", "open_demo_directory(1)");
  ui_controls(ID_ME_FILE_OPENDEMO_VE) = uimenu("Parent", ui_controls(ID_ME_FILE_OPENDEMO), "Label", gettext("Vector demo"), "Callback", "open_demo_directory(2)");
  ui_controls(ID_ME_FILE_OPENDEMO_SP) = uimenu("Parent", ui_controls(ID_ME_FILE_OPENDEMO), "Label", gettext("NGSpice demo"),"Callback", "open_demo_directory(3)");
  
  ui_controls(ID_ME_FILE_LOAD_SIM) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Load simulation results"), "Callback", "load_sim_data()");
  ui_controls(ID_ME_FILE_SAVE_SIM) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Save simulation results"), "Callback", "save_sim_data()");
  
  //ui_controls(ID_ME_FILE_PREFS) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("MonteSci Preferences"), "Callback", "");
  ui_controls(ID_ME_FILE_EXIT) = uimenu("Parent", ui_controls(ID_ME_FILE), "Label", gettext("Exit"), "Callback", "exit_montesci(); close(ui_controls(ID_WINDOW_LIST)(ID_MAIN_WINDOW))");
  

  ui_controls(ID_ME_EDIT) = uimenu("Parent", gui_main, "Label", gettext("Edit"), "Callback", "");
  ui_controls(ID_ME_EDIT_MODEL_CONF) = uimenu("Parent", ui_controls(ID_ME_EDIT), "Label", gettext("Model configuration"), "Callback", " global(""sim_conf""); sleep(200); editor(model_dir + sim_conf); ");
  ui_controls(ID_ME_EDIT_MODEL_PRE) = uimenu("Parent", ui_controls(ID_ME_EDIT), "Label", gettext("Model startup"), "Callback", "global(""sim_conf"");  exec(model_dir + sim_conf);   sleep(200); global(""model_pre_exec""); editor(model_pre_exec);");
  ui_controls(ID_ME_EDIT_MODEL) = uimenu("Parent", ui_controls(ID_ME_EDIT), "Label", gettext("Model file(s)"), "Callback", "open_model_files()");
  ui_controls(ID_ME_EDIT_INVAR) = uimenu("Parent", ui_controls(ID_ME_EDIT), "Label", gettext("Input variable definition"), "Callback", "sleep(200); editor(model_dir + invar_conf);");
  ui_controls(ID_ME_EDIT_OUTVAR) = uimenu("Parent", ui_controls(ID_ME_EDIT), "Label", gettext("Output variable definition"), "Callback", "sleep(200); editor(model_dir + outvar_conf)");
  
  ui_controls(ID_ME_RUN) = uimenu("Parent", gui_main, "Label", gettext("Run"));
  ui_controls(ID_ME_RUN_SIM) = uimenu("Parent", ui_controls(ID_ME_RUN), "Label", gettext("Monte Carlo simulation"), "Callback", "perform_monte_carlo_sim()");
  //ui_controls(ID_ME_RUN_SWEEP) = uimenu("Parent", ui_controls(ID_ME_RUN), "Label", gettext("Variable sweep"), "Callback", "");
    
  ui_controls(ID_ME_VIEW) = uimenu("Parent", gui_main, "Label", gettext("View"));
  ui_controls(ID_ME_VIEW_PLOT) = uimenu("Parent", ui_controls(ID_ME_VIEW), "Label", gettext("Plot window"), "Callback", "create_plot_gui()");
  ui_controls(ID_ME_VIEW_VAR) = uimenu("Parent", ui_controls(ID_ME_VIEW), "Label", gettext("Variable explorer"), "Callback", "create_explorer_controls()");
  ui_controls(ID_ME_VIEW_LOG) = uimenu("Parent", ui_controls(ID_ME_VIEW), "Label", gettext("Log file"), "Callback", "exec(model_dir + sim_conf); sleep(200); global(""montesci_logfile""); editor(model_dir + montesci_logfile)");
  
  ui_controls(ID_ME_HELP) = uimenu("Parent", gui_main, "Label", gettext("Help"));
  ui_controls(ID_ME_HELP_HELP) = uimenu("Parent", ui_controls(ID_ME_HELP), "Label", gettext("Montesci help"), "Callback", "montesci_help()");
  ui_controls(ID_ME_HELP_ABOUT) = uimenu("Parent", ui_controls(ID_ME_HELP), "Label", gettext("About Montesci"), "Callback", "montesci_about()");
  
  
  sleep(200);
  ui_controls(ID_LOG_WINDOW) = uicontrol(gui_main, "style", "text", "position", [30 100 530 540], "VerticalAlignment", "top", "FontName","Arial");
  ui_controls(ID_LOG_WINDOW).FontSize=10;
  ui_controls(ID_LOG_WINDOW).BackgroundColor =  gui_color_bg_log;
  ui_controls(ID_LOG_WINDOW).Enable = "off";  
  
  ui_controls(ID_LOG_WINDOW_SLIDER) =  uicontrol(gui_main, 'style', 'slider', 'position', [545 100 15 540], 'Callback', 'log_slider_handler()');
  ui_controls(ID_LOG_WINDOW_SLIDER).Max = 1;
  ui_controls(ID_LOG_WINDOW_SLIDER).Min = 1;
  ui_controls(ID_LOG_WINDOW_SLIDER).SliderStep = [1, N_LOG_WINDOW];
  ui_controls(ID_LOG_WINDOW_SLIDER).Value = 1;
  
  ui_controls(ID_B_RUN) = uicontrol(gui_main, 'style', 'pushbutton', 'position', [30 50 110 28], 'String', 'Run MC Simulation','Callback','perform_monte_carlo_sim()');
  ui_controls(ID_B_RUN).BackgroundColor  = [ 0.8 0.3 0.3 ];  
  ui_controls(ID_B_SAVE) = uicontrol(gui_main, 'style', 'pushbutton', 'position', [310 50 110 28], 'String', 'Variable Explorer', 'Callback', 'create_explorer_controls()');
  ui_controls(ID_B_SAVE).BackgroundColor  = gui_color_bg_log;
  ui_controls(ID_B_LOAD) = uicontrol(gui_main, 'style', 'pushbutton', 'position', [170 50 110 28], 'String', 'Load Results', 'Callback', 'load_sim_data()');
  ui_controls(ID_B_LOAD).BackgroundColor  = gui_color_bg_log;
  ui_controls(ID_B_PLOT_MAIN) = uicontrol(gui_main, 'style', 'pushbutton', 'position', [450 50 110 28], 'String', 'Plot Results', 'Callback', 'create_plot_gui()');
  ui_controls(ID_B_PLOT_MAIN).BackgroundColor  = gui_color_bg_log;


  ui_controls(ID_B_RUN).enable= "on";
  ui_controls(ID_B_SAVE).enable= "off";
  ui_controls(ID_B_LOAD).enable= "on";
  ui_controls(ID_B_PLOT_MAIN).enable= "off";

  x = uicontrol(gui_main, 'style', 'frame', 'position', [30 20 530 20]);
  x.BackgroundColor = gui_color_bg_log;
  ui_controls(ID_B_PROGRESS) = uicontrol(gui_main, 'style', 'pushbutton', 'position', [30 20 1 20], 'String', '0%');
  ui_controls(ID_B_PROGRESS).BackgroundColor  = [ 0.8 0.3 0.3 ];
  
  progress_bar_per(0);
      
  ttx1= ["  "];
  for i=1:1:200
    ttx1 = [ttx1; "  "] 
  end
  ui_controls(ID_LOGTEXT) = ttx1;
  ui_controls(ID_LOGTEXT_POS) = 1;
  
  log_text("<B> This is MonteSci " + montesci_version+ " </B>", 1, 0);

  log_text("Welcome! ", 1, 0);
  log_text(" ", 1, 0);

  ui_controls(ID_MAIN_WINDOW).parent.anti_aliasing="16x"
  
  global("model_dir");
  global("model_dir_last");
  model_dir_last = list(1);
  
  for i=1:1:6 model_dir_last(i) = "---"; end;
  update_model_dir_menu();
  
  try
    load(montesci_root+"/montesci.last", "model_dir_last"); // save current model directory
    model_dir = model_dir_last(1);    
    exec(model_dir+"model.conf");    
  catch
    log_text("Could not open last working directory, use File/Open or File/Create...", 1, 0);
    log_text("Loading scalar demo model instead...", 1, 0);    
    open_demo_directory(1);
    return;
  end
  
  if (model_dir <> "")
    log_text("Current model directory:  """+ shrink_string(model_dir, 60) +""".", 1,1);
  end  
  
  for i=0:1:5
    number = sprintf("%d", i+1);
    ui_controls(ID_ME_FILE_OPEN_RECENT1+i).Callback = "global(""model_dir_last""); open_sim_directory_d(model_dir_last("+number+"))";
  end
  
  update_model_dir_menu();
  
endfunction

function [] = log_slider_handler()
  update_log_window();
endfunction 

function update_model_dir_menu()
  global("model_dir_last");
  global("ui_controls");
  
  for i=0:1:5    
    ui_controls(ID_ME_FILE_OPEN_RECENT1+i).Label = shrink_string(model_dir_last(i+1), 40); 
  end
    
endfunction

function [] = close_montesci_handler(win,x,y,ibut)
  if (ibut==-1000) 
    exit_montesci();
    return
  end
endfunction

function [] = exit_montesci()
  global("ui_controls");
    
  close_all_plots();
  // close all windows
  for i=length(ui_controls(ID_WINDOW_LIST)):-1:(ID_MAIN_WINDOW+1)
    try
      close(ui_controls(ID_WINDOW_LIST)(i));
    catch
    end
  end
  update_model_dirs();
  disp("Thank you for using MonteSci.");
endfunction

function [] = log_text(text_to_log, log_to_window, log_to_file)
  
  global('ui_controls');
  
  if (ui_controls(ID_LOGTEXT_POS) >  N_LOG_WINDOW)
    ui_controls(ID_LOG_WINDOW_SLIDER).Max = min(ui_controls(ID_LOG_WINDOW_SLIDER).Max+1, 160);
  end  
 
  ui_controls(ID_LOGTEXT_POS) = ui_controls(ID_LOGTEXT_POS)+1;
  
  if (ui_controls(ID_LOGTEXT_POS)) > 200
    ui_controls(ID_LOGTEXT_POS) = 200;
    for i=2:1:200
      ui_controls(ID_LOGTEXT)(i-1) = ui_controls(ID_LOGTEXT)(i);
    end
  end
  
  ui_controls(ID_LOG_WINDOW_SLIDER).Value =  ui_controls(ID_LOGTEXT_POS);
  
  ui_controls(ID_LOGTEXT)(ui_controls(ID_LOGTEXT_POS)) = text_to_log;
  update_log_window();
  
endfunction

function [] = update_log_window()
  global('ui_controls');
  ttx1 = "<HTML><body background = ""file:///" + montesci_root + "/macros/montesci_background.png"">";
  
  for i= ui_controls(ID_LOG_WINDOW_SLIDER).Value :1: ui_controls(ID_LOG_WINDOW_SLIDER).Value + N_LOG_WINDOW 
    ttx1 = [ ttx1 + " &nbsp " + ui_controls(ID_LOGTEXT)(i) + "<BR>"];
  end
  
  s= "&nbsp ";
  for i=1:1:90
    s = s+"&nbsp ";
  end
  
  ttx1 = ttx1 + s    + "</body> </HTML>";
   
  ui_controls(ID_LOG_WINDOW).String = ttx1;
  
endfunction

function [] = error_log_text(text_to_log)
  global('ui_controls');
 
  text_to_log  = "<b><i><font color=red> ERROR " + text_to_log + "</font></i></b>";
  log_text(text_to_log, 1, 1);

endfunction


function [] = progress_bar_per(percentage)
  global('ui_controls');
  
  ui_controls(ID_B_PROGRESS).position(3) = 530 * percentage / 100;  
  ui_controls(ID_B_PROGRESS).String = sprintf("%.1f", percentage) + "%";
    
endfunction