
ID_PLOT_WINDOW = 101;
ID_PLOT_XLIST_IN = 102;
ID_PLOT_XLIST_OUT = 103;
ID_PLOT_YLIST_IN = 104;
ID_PLOT_YLIST_OUT = 105;
ID_PLOT_ZLIST_IN = 106;
ID_PLOT_ZLIST_OUT = 107;
ID_B_PLOT = 108;
ID_B_PLOT_EXIT = 109;
ID_PM_PLOT = 110;
ID_PM_PLOT_HISTDIV = 112;
ID_AR_PLOT_HISTDIV = 113;
ID_PM_PLOT_FIT = 115;
ID_PM_PLOT_FITFKT  =120;
ID_B_PLOT_EDITFITFKT  =122;
ID_T_PLOT_X = 123;
ID_T_PLOT_Y = 125;
ID_T_PLOT_Z = 126;
ID_T_PLOT_FITFKT = 124;
ID_B_CLOSE_PLOTS= 128;
ID_PM_PLOT_3D_GRID_PNTS = 130;
ID_PM_RUN_SEL = 131;


function [] = create_plot_gui()
  global("ui_controls");
  global("in_variables_statistics");
  global("out_variables");
  global("model_fit_fkt");
  global("fit_functions");
  try
    load(model_fit_fkt, "fit_functions");
  catch
  end; 

  ui_controls(ID_B_PLOT_MAIN).enable= "off";

  gui_main = figure(ID_PLOT_WINDOW);
  a=gcf();
  
  a.event_handler = "close_plotgui_handler" ;
  a.event_handler_enable = "on" ;
  
  ui_controls(ID_WINDOW_LIST)(ID_PLOT_WINDOW) = a;
  gui_main.position = [20 20 580 510];
  sleep(200);
  gui_main.figure_name = "MonteSci plot configuration";
  gui_main.background = gui_color_bg;
  
  toolbar(ID_PLOT_WINDOW, "off");
  
  delmenu(ID_PLOT_WINDOW, "File");
  delmenu(ID_PLOT_WINDOW, "Edit");
  delmenu(ID_PLOT_WINDOW, "Tools");
  delmenu(ID_PLOT_WINDOW, "?");
  
  Parent = ui_controls(ID_WINDOW_LIST)(ID_PLOT_WINDOW);
  
  //addmenu(ID_PLOT_WINDOW, "File", ["Save"; "Exit"]);
  sleep(200);
  ui_controls(ID_B_PLOT) = uicontrol(Parent, "style", "pushbutton", "position", [30 20 110 28], "String", "Plot", "Callback", "montesci_plot()");

  ui_controls(ID_B_PLOT).Enable ="off";
  pmstr = "Select plot type|Histogram plot|2D Plot|3D Plot|Surface Plot|Y Plot (model output vectors|XY Plot (model output vectors)";
  ui_controls(ID_PM_PLOT) = uicontrol(Parent, "style", "popupmenu", "position", [30 520 160+90 28], "String", pmstr, "Callback", "eval_plot_popmenu()");
  
  ui_controls(ID_PLOT_XLIST_OUT) = uicontrol(Parent, "style", "listbox", "position", [30 110 160 170], "String", "", "Value", 0, "Callback", "cb_plot_xlist_out()");
  ui_controls(ID_PLOT_XLIST_OUT).BackgroundColor =  gui_plot_input_bg;
  ui_controls(ID_PLOT_YLIST_OUT) = uicontrol(Parent, "style", "listbox", "position", [210 110 160 170], "String", "","Value", 0, "Callback", "cb_plot_ylist_out()");
  ui_controls(ID_PLOT_YLIST_OUT).BackgroundColor =  gui_plot_input_bg;
  ui_controls(ID_PLOT_ZLIST_OUT) = uicontrol(Parent, "style", "listbox", "position", [390 110 160 170], "String", "","Value", 0, "Callback", "cb_plot_zlist_out()");
  ui_controls(ID_PLOT_ZLIST_OUT).BackgroundColor =  gui_plot_input_bg;
  
  ui_controls(ID_PLOT_XLIST_IN) = uicontrol(Parent, "style", "listbox", "position", [30  295 160 170], "String", "", "Value", 0, "Callback", "cb_plot_xlist_in()");
  ui_controls(ID_PLOT_XLIST_IN).BackgroundColor =  gui_plot_output_bg;
  ui_controls(ID_PLOT_YLIST_IN) = uicontrol(Parent, "style", "listbox", "position", [210 295 160 170], "String", "", "Value", 0, "Callback", "cb_plot_ylist_in()");
  ui_controls(ID_PLOT_YLIST_IN).BackgroundColor =  gui_plot_output_bg;
  ui_controls(ID_PLOT_ZLIST_IN) = uicontrol(Parent, "style", "listbox", "position", [390 295 160 170], "String", "", "Value", 0, "Callback", "cb_plot_zlist_in()");
  ui_controls(ID_PLOT_ZLIST_IN).BackgroundColor =  gui_plot_output_bg;
  sleep(200);
  ui_controls(ID_T_PLOT_X) = uicontrol(Parent, "style", "text", "position", [30 480 160 25], "String", "<HTML><B>x-axis or histogram value </B> </HTML>", "FontName","Arial");
  ui_controls(ID_T_PLOT_X).BackgroundColor =  gui_color_bg_log;
  ui_controls(ID_T_PLOT_X).HorizontalAlignment = "center";
  ui_controls(ID_T_PLOT_Y) = uicontrol(Parent, "style", "text", "position", [210 480 160 25], "String", "<HTML><B>y-axis value </B> </HTML>", "FontName","Arial");
  ui_controls(ID_T_PLOT_Y).BackgroundColor =  gui_color_bg_log;
  ui_controls(ID_T_PLOT_Y).HorizontalAlignment = "center";
  ui_controls(ID_T_PLOT_Z) = uicontrol(Parent, "style", "text", "position", [390 480 160 25], "String", "<HTML><B>z-axis value </B> </HTML>", "FontName","Arial");
  ui_controls(ID_T_PLOT_Z).BackgroundColor =  gui_color_bg_log;
  ui_controls(ID_T_PLOT_Z).HorizontalAlignment = "center";

  fill_variable_lists();
    
  ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_disabled_text;
  ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_disabled_text;
  ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_disabled_text;;
  ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_disabled_text;
  ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
  ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
  
  pmstr = "All runs|Successful runs only";
  ui_controls(ID_PM_RUN_SEL) = uicontrol(Parent, "style", "popupmenu", "position", [165 20 110 28], "String", pmstr);
  
  ui_controls(ID_B_PLOT_EDITFITFKT) = uicontrol(Parent, "style", "pushbutton", "position", [300 20 110 28], "String", "Manage fit functions","Callback","create_xyfitfkt_gui()");
    
  ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
  ui_controls(ID_B_CLOSE_PLOTS) = uicontrol(Parent, "style", "pushbutton", "position", [440 20 110 28], "String", "Close all plots", "Callback", "close_all_plots()");
  
  ui_controls(ID_AR_PLOT_HISTDIV) = gui_plot_hstplt_clscnt;
  pmstr = "def. classes";
  for i=1:1:length(ui_controls(ID_AR_PLOT_HISTDIV))
    pmstr = pmstr + sprintf("|%d classes", ui_controls(ID_AR_PLOT_HISTDIV)(i));
  end
  
  ui_controls(ID_PM_PLOT_HISTDIV) = uicontrol(Parent, "style", "popupmenu", "position", [310 520 110 28], "String", pmstr);
  ui_controls(ID_PM_PLOT_HISTDIV).value = 1;
  ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
  
  pmstr = "No Distr. fit|Normal (Gauss)|Beta|Chi square|Exponential|Gamma";
  ui_controls(ID_PM_PLOT_FIT) = uicontrol(Parent, "style", "popupmenu", "position", [440 520 110 28], "String", pmstr);
  ui_controls(ID_PM_PLOT_FIT).value = 1;
  ui_controls(ID_PM_PLOT_FIT).visible = "off";
  
  ui_controls(ID_PM_PLOT_FITFKT) = uicontrol(Parent, "style", "popupmenu", "position", [310 520 240 28], "Callback","gui_fill_fit_fkt()");
  fill_plot_fit_fkts();
  ui_controls(ID_PM_PLOT_FITFKT).value = 1;
  ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
  
  pmstr = "Default x and y grid points|10 x 10 grid|20 x 20 grid|40 x 40 grid|100 x 100 grid|200 x 200 grid|400 x 400 grid";
  ui_controls(ID_PM_PLOT_3D_GRID_PNTS) = uicontrol(Parent, "style", "popupmenu", "position", [310 520 240 28], "String", pmstr);
  ui_controls(ID_PM_PLOT_3D_GRID_PNTS).value = 1;
  ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
  
  
  
  ui_controls(ID_T_PLOT_FITFKT) = uicontrol(Parent, "style", "text", "position", [30 65 520 25], "String", "<HTML><B>&nbsp Fit function:</B> none selected.</HTML>", "FontName","Arial");
  ui_controls(ID_T_PLOT_FITFKT).BackgroundColor =  gui_color_bg_log;
       
endfunction

function [] = fill_variable_lists()
  global("ui_controls");
  global("input_variables_statistics");
  global("output_variables");
  
  instr1 = "";
  for i=1:1:in_variables_statistics(ID_INVAR_COUNT)
    instr1 = instr1 + in_variables_statistics(ID_INVAR_NAME)(i) + "|";
  end
  
  ui_controls(ID_PLOT_XLIST_IN).String = instr1;
  ui_controls(ID_PLOT_YLIST_IN).String = instr1;
  ui_controls(ID_PLOT_ZLIST_IN).String = instr1;

  instr1 = "";
  for i=1:1:out_variables(ID_OUTVAR_COUNT)
    if (out_variables(ID_OUTVAR_TYPE)(i) == "scalar")
      instr1 = instr1 + out_variables(ID_OUTVAR_NAME)(i) + "|";
    else
      instr1 = instr1 + out_variables(ID_OUTVAR_NAME)(i) + "- vector|";
    end
  end
  
  ui_controls(ID_PLOT_XLIST_OUT).String = instr1;
  ui_controls(ID_PLOT_YLIST_OUT).String = instr1;
  ui_controls(ID_PLOT_ZLIST_OUT).String = instr1


endfunction

function [] = close_plotgui_handler(win,x,y,ibut)
  global("ui_controls");
  if (ibut==-1000) 
     close_all_plots();
      ui_controls(ID_B_PLOT_MAIN).enable= "on";
   return
  end
endfunction

function [] =gui_fill_fit_fkt()
  global("ui_controls");
  global("fit_functions");
  if (ui_controls(ID_PM_PLOT_FITFKT).value ~= 1)
    ui_controls(ID_T_PLOT_FITFKT).String = "Fit: "+ fit_functions( ui_controls(ID_PM_PLOT_FITFKT).value)(1);
  else
    ui_controls(ID_T_PLOT_FITFKT).String = "Fit: No fit selected";
  end
  
endfunction

function [] = fill_plot_fit_fkts()
  global("ui_controls");
  global("fit_functions");

  pmstr = "No fit";  
  for i=2:1:length(fit_functions)
    pmstr = pmstr+"|"+ fit_functions(i)(3);
  end;
  ui_controls(ID_PM_PLOT_FITFKT).String = pmstr;
  
endfunction

function [] = eval_plot_popmenu()
    global("ui_controls");
    
    if (ui_controls(ID_PM_PLOT).Value == 1) // Selection prompt
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";   
      ui_controls(ID_B_PLOT).Enable ="off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";      

    end
    
    if (ui_controls(ID_PM_PLOT).Value == 2) // Histogram
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "on";
      ui_controls(ID_PM_PLOT_FIT).visible = "on";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
    
    end
    
    if (ui_controls(ID_PM_PLOT).Value == 3) //2D Plot
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";   
      ui_controls(ID_PM_PLOT_FITFKT).visible = "on";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="on";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
    end
   
    if (ui_controls(ID_PM_PLOT).Value == 4) //3D Plot
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "on";
       
    end
    
    if (ui_controls(ID_PM_PLOT).Value == 5) //Surface Plot
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "on";
       
    end
    
    
    if (ui_controls(ID_PM_PLOT).Value == 6) //y waveform plot
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
       
    end

    if (ui_controls(ID_PM_PLOT).Value == 7) //xy waveform plot
      ui_controls(ID_PLOT_XLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_YLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor = gui_plot_enabled_text;
      ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor = gui_plot_disabled_text;
      ui_controls(ID_PM_PLOT_HISTDIV).visible = "off";
      ui_controls(ID_PM_PLOT_FIT).visible = "off";
      ui_controls(ID_PM_PLOT_FITFKT).visible = "off";
      ui_controls(ID_B_PLOT_EDITFITFKT).Enable="off";
      ui_controls(ID_PM_PLOT_3D_GRID_PNTS).visible = "off";
    end
    
endfunction


function [x_sel, y_sel, z_sel] = get_xyz_list_selection()
  global("ui_controls");
  
  if (length(ui_controls(ID_PLOT_XLIST_IN).Value) > 0) 
    x_sel(1) = ui_controls(ID_PLOT_XLIST_IN).Value(1);
  else 
    x_sel(1) = 0; 
  end

  if (length(ui_controls(ID_PLOT_XLIST_OUT).Value) > 0) 
    x_sel(2) = ui_controls(ID_PLOT_XLIST_OUT).Value(1);
  else 
    x_sel(2) = 0; 
  end
  
  if (length(ui_controls(ID_PLOT_YLIST_IN).Value) > 0) 
    y_sel(1) = ui_controls(ID_PLOT_YLIST_IN).Value(1);
  else 
    y_sel(1) = 0; 
  end

  if (length(ui_controls(ID_PLOT_YLIST_OUT).Value) > 0) 
    y_sel(2) = ui_controls(ID_PLOT_YLIST_OUT).Value(1);
  else 
    y_sel(2) = 0; 
  end
  
  if (length(ui_controls(ID_PLOT_ZLIST_IN).Value) > 0) 
    z_sel(1) = ui_controls(ID_PLOT_ZLIST_IN).Value(1);
  else 
    z_sel(1) = 0; 
  end

  if (length(ui_controls(ID_PLOT_ZLIST_OUT).Value) > 0) 
    z_sel(2) = ui_controls(ID_PLOT_ZLIST_OUT).Value(1);
  else 
    z_sel(2) = 0; 
  end

endfunction


function [] = cb_plot_xlist_out()
    global("ui_controls");
    global("out_variables");
    
    if (  (ui_controls(ID_PLOT_XLIST_IN).Value ~= 0) & (ui_controls(ID_PLOT_XLIST_OUT).Value ~= 0) )
      ui_controls(ID_PLOT_XLIST_IN).Value = 0;
    end 
    
    if (ui_controls(ID_PLOT_XLIST_OUT).ForegroundColor == gui_plot_disabled_text)
      ui_controls(ID_PLOT_XLIST_OUT).Value = 0; 
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end
    
    if (ui_controls(ID_PM_PLOT).Value == 6) | (ui_controls(ID_PM_PLOT).Value == 7) 
      selected = ui_controls(ID_PLOT_XLIST_OUT).Value;
      if out_variables(ID_OUTVAR_TYPE)(selected) ~= "vector"
        ui_controls(ID_PLOT_XLIST_OUT).Value = 0;
      end
    end
    
endfunction

function [] = cb_plot_xlist_in()
    global("ui_controls");
    
    if (  (ui_controls(ID_PLOT_XLIST_OUT).Value ~= 0) & (ui_controls(ID_PLOT_XLIST_IN).Value ~= 0) )
      ui_controls(ID_PLOT_XLIST_OUT).Value = 0;
    end 
    
    if (ui_controls(ID_PLOT_XLIST_IN).ForegroundColor == gui_plot_disabled_text)
    ui_controls(ID_PLOT_XLIST_IN).Value = 0;     
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end
    
endfunction


function [] = cb_plot_ylist_out()
    global("ui_controls");
    
    if (  (ui_controls(ID_PLOT_YLIST_IN).Value ~= 0) & (ui_controls(ID_PLOT_YLIST_OUT).Value ~= 0) )
      ui_controls(ID_PLOT_YLIST_IN).Value = 0;
    end 
    
    if (ui_controls(ID_PLOT_YLIST_OUT).ForegroundColor == gui_plot_disabled_text)
      ui_controls(ID_PLOT_YLIST_OUT).Value = 0; 
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end
    
    if (ui_controls(ID_PM_PLOT).Value == 6)
      selected = ui_controls(ID_PLOT_YLIST_OUT).Value;
      if out_variables(ID_OUTVAR_TYPE)(selected) ~= "vector"
        ui_controls(ID_PLOT_YLIST_OUT).Value = 0;
      end
    end
endfunction

function [] = cb_plot_ylist_in()
    global("ui_controls");
    
    if (  (ui_controls(ID_PLOT_YLIST_OUT).Value ~= 0) & (ui_controls(ID_PLOT_YLIST_IN).Value ~= 0) )
      ui_controls(ID_PLOT_YLIST_OUT).Value = 0;
    end 
    
    if (ui_controls(ID_PLOT_YLIST_IN).ForegroundColor == gui_plot_disabled_text)
    ui_controls(ID_PLOT_YLIST_IN).Value = 0; 
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end    
endfunction

function [] = cb_plot_zlist_out()
    global("ui_controls");
    
    if (  (ui_controls(ID_PLOT_ZLIST_IN).Value ~= 0) & (ui_controls(ID_PLOT_ZLIST_OUT).Value ~= 0) )
      ui_controls(ID_PLOT_ZLIST_IN).Value = 0;
    end 
    
    if (ui_controls(ID_PLOT_ZLIST_OUT).ForegroundColor == gui_plot_disabled_text)
      ui_controls(ID_PLOT_ZLIST_OUT).Value = 0; 
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end
endfunction

function [] = cb_plot_zlist_in()
    global("ui_controls");
    
    if (  (ui_controls(ID_PLOT_ZLIST_OUT).Value ~= 0) & (ui_controls(ID_PLOT_ZLIST_IN).Value ~= 0) )
      ui_controls(ID_PLOT_ZLIST_OUT).Value = 0;
    end
     
    if (ui_controls(ID_PLOT_ZLIST_IN).ForegroundColor == gui_plot_disabled_text)
    ui_controls(ID_PLOT_ZLIST_IN).Value = 0; 
    end
    
    [x y z] = get_xyz_list_selection();
    if ((sum(x + y + z)) > 0)
      ui_controls(ID_B_PLOT).Enable ="on";
    end
endfunction


function [] = close_all_plots()
  global("ui_controls");
  for i=length( ui_controls(ID_PLOT_LIST)):-1:1
    try
      close(ui_controls(ID_PLOT_LIST)(i));
      ui_controls(ID_PLOT_LIST)(i) = null();
    catch
    end
  end      
endfunction
