
ID_VAR_EXPLORER = 801;
ID_VAR_ME_FILE = 802;
ID_VAR_ME_CSV = 803;
ID_VAR_ME_VIEW = 804;
ID_VAR_ME_VIEW_FILTER = 805;
ID_VAR_ME_FICLOSE = 806;
ID_VAR_STATUS = 807;

ID_FILTER_VALID = 1;
ID_FILTER1 = 2;
ID_FILTER2 = 3;
ID_FILTER3 = 4;
ID_FILTER4 = 5;
ID_FILTER5 = 6;
ID_FILTER_VAR =   2;
ID_FILTER_COMP = 3;
ID_FILTER_VAL = 4;
ID_FILTER_INOUTVAR = 5;

size_x = 1024;
size_y =735;
height_element = 18;
margin = 10;
margin_y = 30;
length_run_button = 70;
length_element = 100;

funcprot(0);
function [] = create_explorer_controls()  
  
  global("expl_sort_index");
  global("expl_sort_direction");

  expl_sort_index = 0;
  expl_sort_direction = 1;

  global("N_RUNS");
  global('out_variables');
  global("in_variables_statistics");
  global("n_invar");  
  global("n_outvar");
  global("ui_controls");
  
  ui_controls(ID_B_SAVE).enable= "off";
  
  if (n_run <> N_RUNS) return; end;
   
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  n_outvar = out_variables(ID_OUTVAR_COUNT);
  
  N_VAR = n_invar + n_outvar;

  gui_var_explorer = figure(ID_VAR_EXPLORER);
    
  gui_var_explorer.position = [0 0 size_x size_y-40+margin_y];
  gui_var_explorer.figure_name = "MonteSci variable explorer";
  a=gcf();
  toolbar(ID_VAR_EXPLORER, 'off'),
  delmenu(ID_VAR_EXPLORER, 'File');
  delmenu(ID_VAR_EXPLORER, 'Edit');
  delmenu(ID_VAR_EXPLORER, 'Tools');
  delmenu(ID_VAR_EXPLORER, '?');
  
  a.event_handler = 'close_explorer_handler' ;
  a.event_handler_enable = "on" ;
  
  ui_controls(ID_VAR_ME_FILE) = uimenu("Parent", gui_var_explorer, "Label", gettext("File")); 
  ui_controls(ID_VAR_ME_CSV) = uimenu("Parent", ui_controls(ID_VAR_ME_FILE), "Label", gettext("Save list as CSV"), "Callback", "explorer_file_save()");
  
  //ui_controls(ID_VAR_ME_FICLOSE) = uimenu("Parent", ui_controls(ID_VAR_ME_FILE), "Label", gettext("Close"), "Callback", "");

  //ui_controls(ID_VAR_ME_VIEW) = uimenu("Parent", gui_var_explorer, "Label", gettext("View")); 
  //ui_controls(ID_VAR_ME_VIEW_FILTER) = uimenu("Parent",   ui_controls(ID_VAR_ME_VIEW), "Label", gettext("Variable filter GUI"), "Callback", "");
  
  
  gui_var_explorer.background = gui_color_bg;
  ui_controls(ID_VAR_EXPLORER) = gui_var_explorer; 
  
  ui_controls(ID_WINDOW_LIST)(ID_VAR_EXPLORER) = a;  

  run_buttons = list();
  //run_buttons = list();
  //run_buttons = list();
  list_elements = list();
  global("var_buttons");
  global("run_buttons");
  global("unit_buttons");
  global("list_elements");


  elements_y = floor((size_y-2*margin-height_element*2)/height_element)-1;
  elements_x = floor((size_x-2*margin-length_run_button-height_element)/length_element);
  
  global("slider_hor");
  slider_hor =  uicontrol(gui_var_explorer, 'style', 'slider', 'position', [margin margin+margin_y size_x-margin-length_element+length_run_button height_element], 'Callback', 'fill_values([])');
  slider_hor.Max = N_VAR-elements_x+1;
  slider_hor.Min = 1;
  slider_hor.SliderStep = [1, elements_x];
  slider_hor.Value = 1;
    
  global("slider_ver");
  slider_ver =  uicontrol(gui_var_explorer, 'style', 'slider', 'position', [size_x-margin-height_element height_element+margin+margin_y height_element size_y-height_element*1-2*margin], 'Callback', 'fill_values([])');
  slider_ver.Max = N_RUNS-elements_y+1;
  slider_ver.Min = 1;
  slider_ver.SliderStep = [1, elements_y];
  slider_ver.Value = 1;
  
  for i=1:1:elements_y
    run_buttons(i) =uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [margin margin_y+size_y-margin-(i+2)*height_element length_run_button height_element], 'Verticalalignment', 'middle', 'Callback', 'post_run_exec('+string(i)+')');
  end
  uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [margin margin_y+size_y-margin-(1)*height_element length_run_button height_element], 'Verticalalignment', 'middle',  'String' , 'Variable');
  uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [margin margin_y+size_y-margin-(2)*height_element length_run_button height_element], 'Verticalalignment', 'middle',  'String' , "Run", "Callback", "explorer_sort(0)");
  
  
  for i=0:1:elements_x-1
    var_buttons(i+1) = uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [margin+length_run_button+i*length_element margin_y+size_y-height_element-margin length_element height_element], 'Verticalalignment', 'middle');    
  end
  
  for i=0:1:elements_x-1
    unit_buttons(i+1) = uicontrol(gui_var_explorer, 'style', 'text', 'position', [margin+length_run_button+i*length_element margin_y+size_y-2*height_element-margin length_element height_element], 'Verticalalignment', 'middle', 'Relief', 'raised', 'Horizontalalignment', 'center');
  end
    
  for i=0:1:elements_x-1
    for j=1:1:elements_y       
      list_elements(i*elements_y+j) = uicontrol(gui_var_explorer, 'style', 'text', 'position', [margin+length_run_button+i*length_element margin_y+size_y-(j+2)*height_element-margin length_element height_element], 'Verticalalignment', 'middle', 'Horizontalalignment', 'center', 'Relief', 'groove');        
    end
  end
  
  ui_controls(ID_VAR_STATUS) = uicontrol(gui_var_explorer, 'style', 'text', 'position', [margin, margin, size_x-2*margin, 22], 'Verticalalignment', 'middle');
  ui_controls(ID_VAR_STATUS).BackgroundColor = gui_color_bg_log;
  
  sleep(100);
  create_filter_controls();
  sleep(100);    
  
  
  filter_settings = list(1);
  filter_settings(ID_FILTER_VALID) = %F;
  filter_element = list(1);
  filter_element(ID_FILTER_VAR) = 0;
  filter_element(ID_FILTER_INOUTVAR) = 1; // -1 input, 1 output
  filter_element(ID_FILTER_COMP) = 1;
  filter_element(ID_FILTER_VAL) = 0;
  
  filter_settings(ID_FILTER1) = filter_element;
  filter_settings(ID_FILTER2) = filter_element;
  filter_settings(ID_FILTER3) = filter_element;
  filter_settings(ID_FILTER4) = filter_element;
  filter_settings(ID_FILTER5) = filter_element;
  
  global("filter_settings");
  
  fill_values([]);
   
endfunction  

function [] = close_explorer_handler(win,x,y,ibut)
global("ui_controls");

  if (ibut==-1000) 
    try
      close(ui_controls(ID_WINDOW_LIST)(ID_VAR_FILTER));
    catch
    end    
          ui_controls(ID_B_SAVE).enable= "on";
  end
endfunction


function [] = log_var_explorer(text)
  global("ui_controls");
  ui_controls(ID_VAR_STATUS).String = "<HTML><BODY> &nbsp " + text +" </BODY> </HTML>"; 
endfunction

ID_VAR_FILTER = 901;
ID_B_EXPL_APPLY = 902;
ID_B_EXPL_SAVE = 903;
ID_B_EXPL_LOAD = 919;
ID_POP_VAR1 = 904;
ID_POP_SEL1 = 905;
ID_POP_VAL1 = 906;
ID_POP_VAR2 = 907;
ID_POP_SEL2 = 908;
ID_POP_VAL2 = 909;
ID_POP_VAR3 = 910;
ID_POP_SEL3 = 911;
ID_POP_VAL3 = 912;
ID_POP_VAR4 = 913;
ID_POP_SEL4 = 914;
ID_POP_VAL4 = 915;
ID_POP_VAR5 = 916;
ID_POP_SEL5 = 917;
ID_POP_VAL5 = 918;
ID_POP_VALID = 919;

function [] = create_filter_controls()
  
  global("N_RUNS");
  global('out_variables');
  global("in_variables_statistics");
  global("n_invar");  
  global("n_outvar");
  global("ui_controls");
   
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  n_outvar = out_variables(ID_OUTVAR_COUNT);
  
  N_VAR = n_invar + n_outvar;

  gui_var_explorer = figure(ID_VAR_FILTER);

  gui_var_explorer.position = [0 0 412 190];
  gui_var_explorer.figure_name = "MonteSci variable explorer (filter)";
  a=gcf();
  toolbar(ID_VAR_FILTER, 'off'),
  delmenu(ID_VAR_FILTER, 'File');
  delmenu(ID_VAR_FILTER, 'Edit');
  delmenu(ID_VAR_FILTER, 'Tools');
  delmenu(ID_VAR_FILTER, '?');
  
  gui_var_explorer.background = gui_color_bg;
  ui_controls(ID_VAR_FILTER) = gui_var_explorer; 
  ui_controls(ID_WINDOW_LIST)(ID_VAR_FILTER) = a;
  
  ui_controls(ID_POP_VAR1) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 50 160 22], 'String', "Chose Variable", 'Value', 0);
  ui_controls(ID_POP_SEL1) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [200 50 70 22], 'String', "==|<|>|<=|>=", 'Value', 0);
  ui_controls(ID_POP_VAL1) = uicontrol( gui_var_explorer, 'style', 'edit', 'position', [290 50 100 20], 'String', "enter value", 'Value', 0);
  
  ui_controls(ID_POP_VAR2) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 80 160 22], 'String', "Chose Variable", 'Value', 0);
  ui_controls(ID_POP_SEL2) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [200 80 70 22], 'String', "==|<|>|<=|>=", 'Value', 0);
  ui_controls(ID_POP_VAL2) = uicontrol( gui_var_explorer, 'style', 'edit', 'position', [290 80 100 22], 'String', "enter value", 'Value', 0);

  ui_controls(ID_POP_VAR3) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 110 160 22], 'String', "Chose Variable", 'Value', 0);
  ui_controls(ID_POP_SEL3) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [200 110 70 22], 'String', "==|<|>|<=|>=", 'Value', 0);
  ui_controls(ID_POP_VAL3) = uicontrol( gui_var_explorer, 'style', 'edit', 'position', [290 110 100 22], 'String', "enter value", 'Value', 0);
  
  ui_controls(ID_POP_VAR4) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 140 160 22], 'String', "Chose Variable", 'Value', 0);
  ui_controls(ID_POP_SEL4) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [200 140 70 22], 'String', "==|<|>|<=|>=", 'Value', 0);
  ui_controls(ID_POP_VAL4) = uicontrol( gui_var_explorer, 'style', 'edit', 'position', [290 140 100 22], 'String', "enter value", 'Value', 0);
  
  ui_controls(ID_POP_VAR5) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 170 160 22], 'String', "Chose Variable", 'Value', 0);
  ui_controls(ID_POP_SEL5) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [200 170 70 22], 'String', "==|<|>|<=|>=", 'Value', 0);
  ui_controls(ID_POP_VAL5) = uicontrol( gui_var_explorer, 'style', 'edit', 'position', [290 170 100 22], 'String', "enter value", 'Value', 0);
  
  ui_controls(ID_B_EXPL_APPLY) = uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [280 10 110 22], 'String', 'Apply filter','Callback','explorer_filter_callback()");  
  ui_controls(ID_B_EXPL_LOAD) = uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [150 10 110 22], 'String', 'Load filter','Callback','explorer_filter_load()');
  ui_controls(ID_B_EXPL_SAVE) = uicontrol(gui_var_explorer, 'style', 'pushbutton', 'position', [20 10 110 22], 'String', 'Save filter','Callback','explorer_filter_save()');
  
  ui_controls(ID_B_EXPL_APPLY).BackgroundColor = gui_color_bg_log;
  ui_controls(ID_B_EXPL_LOAD).BackgroundColor = gui_color_bg_log;
  ui_controls(ID_B_EXPL_SAVE).BackgroundColor = gui_color_bg_log;
  
  ui_controls(ID_POP_VALID) = uicontrol( gui_var_explorer, 'style', 'popupmenu', 'position', [20 205 370 22], 'String', "Show all runs| Show only successful runs", 'Value', 0); 
   
endfunction  

function [] = explorer_file_save()
  global("in_variables_statistics");
  global("out_variables");
  global("model_input");
  global("model_output");
  
  filename = uigetfile(["*.csv"], model_dir);
  if (filename=="") return; end
  
  if (length(strindex(filename, ".csv"))==0)  // append ".mscl" if not already part of the name
    filename = filename + ".csv";
  end
  
  try
    outfile = mopen(filename, "w");
  catch
    messagebox("Could not open file for writing.", "Error", "error", ["Continue"], "modal");
    return;
  end
  
  try
    n_invar = in_variables_statistics(ID_INVAR_COUNT);
    n_outvar = out_variables(ID_OUTVAR_COUNT);
  
    for i=1:1:n_invar
      mfprintf(outfile, "%s; ", in_variables_statistics(ID_INVAR_NAME)(i));
    end
  
    for i=1:1:n_outvar
      mfprintf(outfile, "%s; ", out_variables(ID_OUTVAR_NAME)(i));
    end
  
    mfprintf(outfile, "\n");
  
    indices = get_sort_order();
    
    for j=1:1:length(indices)
     
      for i=1:1:n_invar
        mfprintf(outfile, "%E; ", model_input(i)(indices(j)));
      end
  
      for i=1:1:n_outvar
        mfprintf(outfile, "%E, ", model_output(i)(indices(j)));
        mfprintf(outfile, "; ");
      end
    
      mfprintf(outfile, "\n");
    end  
  catch
    log_var_explorer("Error saving file " + filename +"...");
  end
  log_var_explorer("Saved file " + filename + ".");
  
  
  mclose(filename);
  
  
endfunction

function [] =  explorer_filter_save()
  global("filter_settings");
  if (explorer_filter_callback() > 0) return; end;
  
  filename = uigetfile(["*.mscl"], model_dir);
  if (filename=="") return; end
  
   if (length(strindex(filename, ".mscl"))==0)  // append ".mscl" if not already part of the name
      filename = filename + ".mscl";
    end
  
  try
    save(filename, filter_settings);
  catch
    error_log_text("401: Filter File could not be saved.");
  end
  
endfunction



function [] =  explorer_filter_load()
  global("filter_settings");
  global("ui_controls");
  global("in_variables_statistics");
  
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  
  filename = uigetfile(["*.mscl"], model_dir);
  if (filename=="") return; end
  
  try
    load(filename, "filter_settings");
  catch
    error_log_text("402: Filter File could not be loaded.");
  end
  
  //disp(ui_controls(ID_POP_VAR1).Value);
  
  
  if (filter_settings(ID_FILTER1)(ID_FILTER_VAR) ~= 0)
    ui_controls(ID_POP_VAR1).Value = filter_settings(ID_FILTER1)(ID_FILTER_VAR) + (filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR)+1)/2 * n_invar+1;  
    ui_controls(ID_POP_SEL1).Value =  filter_settings(ID_FILTER1)(ID_FILTER_COMP);
    ui_controls(ID_POP_VAL1).String = sprintf("%.4E", filter_settings(ID_FILTER1)(ID_FILTER_VAL));
  else
    ui_controls(ID_POP_VAR1).Value =  1;  
    ui_controls(ID_POP_SEL1).Value =  1;
    ui_controls(ID_POP_VAL1).String = "enter value";
  end
   
  
  if (filter_settings(ID_FILTER2)(ID_FILTER_VAR) ~= 0)
    ui_controls(ID_POP_VAR2).Value = filter_settings(ID_FILTER2)(ID_FILTER_VAR) + (filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR)+1)/2 * n_invar+1;  
    ui_controls(ID_POP_SEL2).Value =  filter_settings(ID_FILTER2)(ID_FILTER_COMP);
    ui_controls(ID_POP_VAL2).String = sprintf("%.4E", filter_settings(ID_FILTER2)(ID_FILTER_VAL)); 
  else
    ui_controls(ID_POP_VAR2).Value =  1;  
    ui_controls(ID_POP_SEL2).Value =  1;
    ui_controls(ID_POP_VAL2).String = "enter value";
  end

  
  if (filter_settings(ID_FILTER3)(ID_FILTER_VAR) ~= 0)
    ui_controls(ID_POP_VAR3).Value = filter_settings(ID_FILTER3)(ID_FILTER_VAR) + (filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR)+1)/2 * n_invar+1;  
    ui_controls(ID_POP_SEL3).Value =  filter_settings(ID_FILTER3)(ID_FILTER_COMP);
    ui_controls(ID_POP_VAL3).String = sprintf("%.4E", filter_settings(ID_FILTER3)(ID_FILTER_VAL));
  else
    ui_controls(ID_POP_VAR3).Value =  1;  
    ui_controls(ID_POP_SEL3).Value =  1;
    ui_controls(ID_POP_VAL3).String = "enter value";
  end
 
  
  if (filter_settings(ID_FILTER4)(ID_FILTER_VAR) ~= 0)
    ui_controls(ID_POP_VAR4).Value = filter_settings(ID_FILTER4)(ID_FILTER_VAR) + (filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR)+1)/2 * n_invar+1;  
    ui_controls(ID_POP_SEL4).Value =  filter_settings(ID_FILTER4)(ID_FILTER_COMP);
    ui_controls(ID_POP_VAL4).String = sprintf("%.4E", filter_settings(ID_FILTER4)(ID_FILTER_VAL));
  else
    ui_controls(ID_POP_VAR4).Value =  1;  
    ui_controls(ID_POP_SEL4).Value =  1;
    ui_controls(ID_POP_VAL4).String = "enter value";
  end
 
  
  if (filter_settings(ID_FILTER5)(ID_FILTER_VAR) ~= 0)
    ui_controls(ID_POP_VAR5).Value = filter_settings(ID_FILTER5)(ID_FILTER_VAR) + (filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR)+1)/2 * n_invar+1;  
    ui_controls(ID_POP_SEL5).Value =  filter_settings(ID_FILTER5)(ID_FILTER_COMP);
    ui_controls(ID_POP_VAL5).String = sprintf("%.4E", filter_settings(ID_FILTER5)(ID_FILTER_VAL));
  else
    ui_controls(ID_POP_VAR5).Value =  1;  
    ui_controls(ID_POP_SEL5).Value =  1;
    ui_controls(ID_POP_VAL5).String = "enter value";
  end
 
  
  if (filter_settings(ID_FILTER_VALID) == %T)
    ui_controls(ID_POP_VALID).Value =  2; 
  else
    ui_controls(ID_POP_VALID).Value =  1;
  end
  
  
  fill_values([]);
 
endfunction

function [status] = check_single_filter(id_filter, id_pop_var, id_pop_val, id_pop_sel)
  global("filter_settings");
  global("ui_controls");  
  global("in_variables_statistics");
  
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  status = 0;
  var = ui_controls(id_pop_var).Value -1;  
  if (var ~= 0)
      if (var > n_invar)
      filter_settings(id_filter)(ID_FILTER_INOUTVAR) = 1; // output
      var = var - n_invar;
    else
      filter_settings(id_filter)(ID_FILTER_INOUTVAR) = -1;  // input
    end
    filter_settings(id_filter)(ID_FILTER_VAR) = var;  
    
    filter_settings(id_filter)(ID_FILTER_COMP) = ui_controls(id_pop_sel).Value;
        
    val = ui_controls(id_pop_val).String;    
    try
      execstr("y = " + val);
      filter_settings(id_filter)(ID_FILTER_VAL) = y;
      ui_controls(id_pop_val).BackgroundColor = [0 0 0];
      ui_controls(id_pop_val).FontWeight = "normal";
    catch        
      ui_controls(id_pop_val).BackgroundColor = [0.5 0 0];
      ui_controls(id_pop_val).FontWeight = "bold";
      messagebox("Provide a valid floating point number for highlighted variable.", "Error", "error", ["Continue"], "modal");
      status = 1;
    end  
  else
    filter_settings(id_filter)(ID_FILTER_VAR) = 0;
  end
  
endfunction

function [status] = explorer_filter_callback()
  global("filter_settings");
  global("ui_controls");
  global('out_variables');
  global("in_variables_statistics");
  
  if (ui_controls(ID_POP_VALID).Value == 2)
    filter_settings(ID_FILTER_VALID) = %T;
  else
    filter_settings(ID_FILTER_VALID) = %F;
  end
  
  status = check_single_filter(ID_FILTER1, ID_POP_VAR1, ID_POP_VAL1, ID_POP_SEL1)
  status = status + check_single_filter(ID_FILTER2, ID_POP_VAR2, ID_POP_VAL2, ID_POP_SEL2)
  status = status + check_single_filter(ID_FILTER3, ID_POP_VAR3, ID_POP_VAL3, ID_POP_SEL3)
  status = status + check_single_filter(ID_FILTER4, ID_POP_VAR4, ID_POP_VAL4, ID_POP_SEL4)
  status = status + check_single_filter(ID_FILTER5, ID_POP_VAR5, ID_POP_VAL5, ID_POP_SEL5)
  
  if (status == 0);
     fill_values([]);
  end
endfunction

function [] = fill_filter_values()
  global("ui_controls");
  global('out_variables');
  global("in_variables_statistics");
  
  variable_list = "no variable (inactive)|";
  
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  n_outvar = out_variables(ID_OUTVAR_COUNT); 
  
  for i=1:1:n_invar
    variable_list = variable_list +"in: " +in_variables_statistics(ID_INVAR_NAME)(i) + "|";
  end
  
  for i=1:1:n_outvar
    variable_list = variable_list +"out: "+ out_variables(ID_OUTVAR_NAME)(i) + "|";
  end
  
  oldval = ui_controls(ID_POP_VAR1).Value;
  ui_controls(ID_POP_VAR1).String = variable_list; 
  ui_controls(ID_POP_VAR1).Value = oldval;
    
  oldval = ui_controls(ID_POP_VAR2).Value;
  ui_controls(ID_POP_VAR2).String = variable_list;
  ui_controls(ID_POP_VAR2).Value = oldval;
  
  oldval = ui_controls(ID_POP_VAR3).Value;
  ui_controls(ID_POP_VAR3).String = variable_list;
  ui_controls(ID_POP_VAR3).Value = oldval;
  
  oldval = ui_controls(ID_POP_VAR4).Value;
  ui_controls(ID_POP_VAR4).String = variable_list;
  ui_controls(ID_POP_VAR4).Value = oldval;

  oldval = ui_controls(ID_POP_VAR5).Value;
  ui_controls(ID_POP_VAR5).String = variable_list;
  ui_controls(ID_POP_VAR5).Value = oldval;

endfunction


function [] = explorer_sort(column)
  global("expl_sort_index");  
  global("expl_sort_direction");
  
  if (expl_sort_index == column)
    expl_sort_direction = expl_sort_direction * -1;
  else
    expl_sort_direction = 1; 
  end
  expl_sort_index = column;
  
  fill_values([]);  
  
endfunction


function [filtered_indices] = get_filtered_indices(all_indices, variable, var_inout, condition, value)
  global('model_input');
  global('model_output');

  if (var_inout == -1) // input
    data = model_input(variable)(all_indices);
  else
    data = model_output(variable)(all_indices);
  end
       
  if (condition == 1) // ==
    filtered_indices = all_indices ( find (data == value));
  end
  if (condition == 2) // <
    filtered_indices = all_indices ( find (data < value));
  end  
  if (condition == 3) //>
    filtered_indices = all_indices ( find (data > value));
  end  
  if (condition == 4)// <=
    filtered_indices = all_indices ( find (data <= value));
  end
  if (condition == 5)// >=
    filtered_indices = all_indices ( find (data >= value));
  end
    
  
  //filtered_indices = all_indices;

endfunction


function [valid_indices] = get_valid_indices(all_indices)
  global('model_input');
  global('model_output');
  global('out_variables');
  global("in_variables_statistics");
  global("N_RUNS");

  valid_indices = all_indices;
  
  for i = 1:1:out_variables(ID_OUTVAR_COUNT)
    limits= out_variables(ID_OUTVAR_LIMITS)(i);
    upper_limit = limits(2);
    lower_limit = limits(1);
    
    if (upper_limit > lower_limit)  // valid limits?
      valid_indices = valid_indices(find(model_output(i)(valid_indices) >= lower_limit));            
      valid_indices = valid_indices(find(model_output(i)(valid_indices) <= upper_limit));
    end
  end
    
endfunction


function explorer_index_order = get_sort_order()
  global("N_RUNS");
  global("expl_sort_index");
  global("expl_sort_direction");
  global("model_output")
  global("model_input")    
  global("ui_controls");    
  global("filter_settings");
  
  // filter data
  
  if (filter_settings(ID_FILTER_VALID)== %T)       
    indices = get_valid_indices(1:1:N_RUNS);
  else
    indices = 1:1:N_RUNS;
  end
  
  if (filter_settings(ID_FILTER1)(ID_FILTER_VAR) ~= 0)
    indices = get_filtered_indices(indices, filter_settings(ID_FILTER1)(ID_FILTER_VAR), filter_settings(ID_FILTER1)(ID_FILTER_INOUTVAR), filter_settings(ID_FILTER1)(ID_FILTER_COMP), filter_settings(ID_FILTER1)(ID_FILTER_VAL));
  end
  
  if (filter_settings(ID_FILTER2)(ID_FILTER_VAR) ~= 0)
    indices = get_filtered_indices(indices, filter_settings(ID_FILTER2)(ID_FILTER_VAR), filter_settings(ID_FILTER2)(ID_FILTER_INOUTVAR), filter_settings(ID_FILTER2)(ID_FILTER_COMP), filter_settings(ID_FILTER2)(ID_FILTER_VAL));
  end
  
  if (filter_settings(ID_FILTER3)(ID_FILTER_VAR) ~= 0)
    indices = get_filtered_indices(indices, filter_settings(ID_FILTER3)(ID_FILTER_VAR), filter_settings(ID_FILTER3)(ID_FILTER_INOUTVAR), filter_settings(ID_FILTER3)(ID_FILTER_COMP), filter_settings(ID_FILTER3)(ID_FILTER_VAL));
  end
  
  if (filter_settings(ID_FILTER4)(ID_FILTER_VAR) ~= 0)
    indices = get_filtered_indices(indices, filter_settings(ID_FILTER4)(ID_FILTER_VAR), filter_settings(ID_FILTER4)(ID_FILTER_INOUTVAR), filter_settings(ID_FILTER4)(ID_FILTER_COMP), filter_settings(ID_FILTER4)(ID_FILTER_VAL));
  end
  
  if (filter_settings(ID_FILTER5)(ID_FILTER_VAR) ~= 0)
    indices = get_filtered_indices(indices, filter_settings(ID_FILTER5)(ID_FILTER_VAR), filter_settings(ID_FILTER5)(ID_FILTER_INOUTVAR), filter_settings(ID_FILTER5)(ID_FILTER_COMP), filter_settings(ID_FILTER5)(ID_FILTER_VAL));
  end
  
  
  //indices = get_filtered_indices(indices,  );
  
   
  if (expl_sort_index == 0)                         // simulation run numbers
      data = indices;     
  end
  if (expl_sort_index > 0)                          // inputs
     data = model_input(expl_sort_index)(indices);
  end
  if (expl_sort_index < 0)                          // ouputs
    data = model_output(-1*expl_sort_index)(indices);
  end
  
  if (expl_sort_direction == -1)
    [foo explorer_index_order] = gsort(data);
  else
    [foo explorer_index_order] = gsort(-1*data);
  end  
  
  explorer_index_order = indices(explorer_index_order);
  
     
endfunction


function [] = fill_values(highlight_indices)
try

  sleep(200);
  global("var_buttons");
  global("run_buttons");
  global("unit_buttons");
  global("list_elements");
  global("slider_hor");
  global("N_RUNS");
  global("slider_ver");
  global('model_input');
  global('model_output');
  global('out_variables');
  global("in_variables_statistics");
  global('ui_controls');  
  
  fill_filter_values();
  
  explorer_index_order = get_sort_order();
  variable_count = length(explorer_index_order);
  
  if (length(highlight_indices) > 0)
    if (highlight_indices(1) == -1)
      ui_controls(ID_VAR_EXPLORER).user_data= list(1);
      ui_controls(ID_VAR_EXPLORER).user_data(1) = [];
    else
      ui_controls(ID_VAR_EXPLORER).user_data= list(1);
      ui_controls(ID_VAR_EXPLORER).user_data(1) = highlight_indices;
    end
  end
      
  vv = ui_controls(ID_VAR_EXPLORER).user_data;  
  highlight_indices = vv(1);
     
  n_invar = in_variables_statistics(ID_INVAR_COUNT);
  n_outvar = out_variables(ID_OUTVAR_COUNT); 
  
  n_var = n_invar + n_outvar;
  
  elements_y = floor((size_y-2*margin-height_element*2)/height_element)-1;
  elements_x = floor((size_x-2*margin-length_run_button-height_element)/length_element);
  
  slider_hor.Max = n_var-elements_x+1;
  slider_hor.Min = 1;
  if (slider_hor.Value > slider_hor.Max) slider_hor.Value = 1; end;
  slider_hor.SliderStep = [1, elements_x];
  
  slider_ver.Max = variable_count-elements_y+1;
  slider_ver.Min = 1;
    if (slider_ver.Value > slider_ver.Max) slider_ver.Value = 1; end;
  slider_ver.SliderStep = [1, elements_y];
    
  elements_y = floor((size_y-2*margin-height_element*2)/height_element)-1;
  elements_x = floor((size_x-2*margin-length_run_button-height_element)/length_element)
  
  i=0;
  // input variables
  if (slider_hor.Value <= n_invar)
    for i=1:1:min(n_invar-slider_hor.Value+1, elements_x);
      var_buttons(i).String = in_variables_statistics(ID_INVAR_NAME)(i+slider_hor.Value-1);
      var_buttons(i).Callback = sprintf("explorer_sort(%d)", i+slider_hor.Value-1); 
    end

    for i=1:1:min(n_invar-slider_hor.Value+1, elements_x);
      unit_buttons(i).String = in_variables_statistics(ID_INVAR_UNIT)(i+slider_hor.Value-1);
        
        
      limits= in_variables_statistics(ID_INVAR_LIMITS)(i+slider_hor.Value-1);
      upper_limit = limits(2);
      lower_limit = limits(1);  
            
      for j=1:1:min(variable_count-slider_ver.Value+1, elements_y);
      
      value = model_input(i+slider_hor.Value-1)(explorer_index_order(j+slider_ver.Value-1));
      
      if (length(find(highlight_indices == explorer_index_order(j+slider_ver.Value-1) )) > 0 ) highlight = %T; else highlight=%F; end; 
      
      if (((value >= upper_limit) | (value<= lower_limit)) & (upper_limit > lower_limit))
            
            if (highlight)
              list_elements((i-1)*elements_y+j).String =  "<html><body><B><I><font color=red> " + sprintf("%.3E", value) + "</font></I></B></body></html>";
            else
              list_elements((i-1)*elements_y+j).String =  "<html><body><font color=red> " + sprintf("%.3E", value) + "</font></body></html>";
            end
          else
            if (highlight)
              list_elements((i-1)*elements_y+j).String =  "<html><body><B><I> " + sprintf("%.3E", value) + "</I></B></body></html>";
            else
              list_elements((i-1)*elements_y+j).String =  sprintf("%.3E", value);
            end
          end
        if (highlight)
          list_elements((i-1)*elements_y+j).BackgroundColor =  [1 1 0];
        else
          list_elements((i-1)*elements_y+j).BackgroundColor =  gui_color_bg_log;
        end
      end
       
    end    
  end
    
  
  // output variables
  if (i < elements_x)
    for j=(i+1):1:min(n_outvar+i, elements_x);
      var_buttons(j).String = out_variables(ID_OUTVAR_NAME)(j+slider_hor.Value-n_invar-1);
      var_buttons(j).Callback = sprintf("explorer_sort(%d)", -1 * (j+slider_hor.Value-n_invar-1));
      unit_buttons(j).String = out_variables(ID_OUTVAR_UNIT)(j+slider_hor.Value-n_invar-1); 

      limits= out_variables(ID_OUTVAR_LIMITS)(j-n_invar+slider_hor.Value-1);
      upper_limit = limits(2);
      lower_limit = limits(1);
      
      for k=1:1:min(variable_count-slider_ver.Value+1, elements_y);
        if (length(find(highlight_indices == explorer_index_order(k+slider_ver.Value-1 ))) > 0 ) highlight = %T; else highlight=%F; end;
        if out_variables(ID_OUTVAR_TYPE)(j+slider_hor.Value-n_invar-1)=="scalar"
          value = model_output(j-n_invar+slider_hor.Value-1)(explorer_index_order(k+slider_ver.Value-1));         
          
          if (((value >= upper_limit) | (value<= lower_limit)) & (upper_limit > lower_limit))
            if (highlight)            
              list_elements((j-1)*elements_y+k).String =  "<html><body><B><I><font color=red> " + sprintf("%.3E", value) + "</font></I></B></body></html>";
            else
              list_elements((j-1)*elements_y+k).String =  "<html><body><font color=red> " + sprintf("%.3E", value) + "</font></body></html>";
            end
          else
            if (highlight)
              list_elements((j-1)*elements_y+k).String =  "<html><body><B><I> " + sprintf("%.3E", value) + "</I></B></body></html>";
            else
              list_elements((j-1)*elements_y+k).String =  sprintf("%.3E", value);
            end
          end

        else
          list_elements((j-1)*elements_y+k).String =  "vector";
        end
        if (highlight)
          list_elements((j-1)*elements_y+k).BackgroundColor =  [1 1 0];
        else
          list_elements((j-1)*elements_y+k).BackgroundColor =  gui_color_bg_2;
        end
      end      
    end
  end

  if (j < elements_x)
    for k = (j+1):1:elements_x
      for l = 1:1:elements_y
        list_elements((k-1)*elements_y + l).String = "-"; 
        list_elements((k-1)*elements_y + l).BackgroundColor =  [0.8, 0.8, 0.8];
      end  
    end
  end  
  
  if (variable_count < elements_y)
    for k = 1:1:elements_x
      for l = (variable_count+1):1:elements_y
        list_elements((k-1)*elements_y + l).String = "-";
        list_elements((k-1)*elements_y + l).BackgroundColor =  [0.8, 0.8, 0.8]; 
      end  
    end
  end
  
  
  // run indices
  runs = (1:1:min(variable_count, elements_y))+slider_ver.Value-1;
  
        
  for i=1:1:elements_y;
  
    if (i <= variable_count)
  
    run_fail = 0; 
  
    for j=1:1:out_variables(ID_OUTVAR_COUNT)
      if (out_variables(ID_OUTVAR_TYPE)(j)=="scalar")
        limits= out_variables(ID_OUTVAR_LIMITS)(j);
        upper_limit = limits(2);
        lower_limit = limits(1);        
        if (upper_limit > lower_limit)
          if ( (model_output(j)(explorer_index_order(runs(i))) > upper_limit) | (model_output(j)(explorer_index_order(runs(i))) < lower_limit) ) run_fail = 1; end
        end        
      end      
    end
  
    for j=1:1:in_variables_statistics(ID_INVAR_COUNT)
        limits= in_variables_statistics(ID_INVAR_LIMITS)(j);
        upper_limit = limits(2);
        lower_limit = limits(1);        
        if (upper_limit > lower_limit)
          if ( (model_input(j)(explorer_index_order(runs(i))) > upper_limit) | (model_input(j)(explorer_index_order(runs(i))) < lower_limit) ) run_fail = 1; end
        end        
    end
   
  
    if (run_fail == 0)
        run_buttons(i).String = sprintf("%d", explorer_index_order(runs(i)));
        run_buttons(i).Callback = "post_run_exec(" + string(explorer_index_order(runs(i)))+ ")";
      else
       run_buttons(i).String = "<html><body><B><font color=red> " + sprintf("%d", explorer_index_order(runs(i))) + "</font></B></body></html>";
       run_buttons(i).Callback = "post_run_exec("+string(explorer_index_order(runs(i)))+")";
    end    
    
  else
    run_buttons(i).String = '-';
       run_buttons(i).Callback = "";
  end
  end
  log_var_explorer(sprintf("Showing %d runs...", variable_count));
  
  catch
    log_var_explorer("Error during data processing.");
  end

endfunction

