

function [] = montesci_plot3d(xdata, ydata, zdata, xlab, ylab, zlab, tit, N_plot, valid_runs)
  
  x_axis = linspace(min(xdata), max(xdata), N_plot)
  y_axis = linspace(min(ydata), max(ydata), N_plot)

  z_data = zeros(N_plot, N_plot);

  data_grid_2d = [decimate(xdata, N_dec_3d) decimate(ydata, N_dec_3d)]';
  z_data_dec = decimate(zdata, N_dec_3d); 
  
  f = scf();
  a = gca();
  fs = a.parent.figure_size;
  sizex= 200;
  sizey= 30;
  x= fs(1) * 0.5-sizex/2; 
  y= fs(2) * 0.5-sizey/2; 
  b=uicontrol(a.parent, "Style","text","String","Interpolating grid: 0 percent", "Position", [x y sizex sizey]);
  b.visible = "on";
  b.Relief = "groove"
  b.BackgroundColor = gui_color_bg_log;
  b.HorizontalAlignment = "center";
  
    
  for (i=1:1:N_plot) //x
    for (j=1:1:N_plot) //y
      grid_vec = [x_axis(i); y_axis(j)]
      distances = data_grid_2d;
      distances(1,:) = distances(1,:) -grid_vec(1);
      distances(2,:) = distances(2,:) -grid_vec(2);
      dist_quad = distances(1,:)**2 + distances(2,:)**2;
      [foo index] = min(dist_quad);
      z_data(i, j) = z_data_dec(index(1));   
          
    end
    b.String = "Interpolating grid: " + sprintf("%d",i/N_plot*100) + "% ...";
  end
  
  b.visible = "off";

   
  plot3d( x_axis, y_axis, z_data, flag = [1,2,4]); //, ebox = [min(x_axis), max(x_axis), min(y_axis), max(y_axis), min(z_data), max(z_data)] ); 
  a=gca();
  a.cube_scaling = "on";
  h=gce(); //get handle on current entity (here the surface)
  append_plot_to_list(a.parent);
  xlabel(xlab);
  ylabel(ylab);
  zlabel(zlab);
  title(tit);

  a.grid=[1 1 1]; //make grids
  h.color_flag=1; //color according to z
  h.color_mode=-2;  //remove the facets boundary by setting color_mode to white color
  h.color_flag=1; //color according to given colors
  h.color_mode = -1; // put the facets boundary back by setting color_mode to black color
  f=gcf();//get the handle of the parent figure    
  f.color_map=jetcolormap(128);


  a.parent.background = -2;
  //a.parent.figure_name = "Plot test graphics...";
  
  a.parent.color_map(135,:) = [0.95 0.9 1 ];
  a.parent.background = 135;
  //a.children.children(1).thickness = 2;
  a.title.font_size = 3;
  a.title.font_style=5;
  a.x_label.font_style = 6;
  a.x_label.font_size = 2;
  a.y_label.font_style = 6;
  a.y_label.font_size = 2;
  a.foreground = 2;
  
endfunction

