
function [] = montesci_surface(xdata, ydata, zdata, xlab, ylab, zlab, tit, N_plot, valid_runs)
  
  x_axis = linspace(min(xdata), max(xdata), N_plot);
  y_axis = linspace(min(ydata), max(ydata), N_plot);

  z_data = zeros(N_plot, N_plot);

  data_grid_2d = [decimate(xdata, N_dec_3d) decimate(ydata, N_dec_3d)]';
   z_data_dec = decimate(zdata, N_dec_3d); 
  
  f = scf();
  a = gca();
  append_plot_to_list(a.parent);
  fs = a.parent.figure_size;
  sizex= 200;
  sizey= 30;
  x= fs(1) * 0.5-sizex/2; 
  y= fs(2) * 0.5-sizey/2; 
  b=uicontrol(a.parent, "Style","text","String","Interpolating grid: 0 percent", "Position", [x y sizex sizey]);
  b.visible = "on";
  b.Relief = "groove"
  b.BackgroundColor = gui_color_bg_log;
  b.HorizontalAlignment = "center";
  
    
  for (i=1:1:N_plot) //x
    for (j=1:1:N_plot) //y
      grid_vec = [x_axis(i); y_axis(j)]
      distances = data_grid_2d;
      distances(1,:) = distances(1,:) -grid_vec(1);
      distances(2,:) = distances(2,:) -grid_vec(2);
      dist_quad = distances(1,:)**2 + distances(2,:)**2;
      [foo index] = min(dist_quad);
      z_data(i, j) = z_data_dec(index(1));   
          
    end
    b.String = "Interpolating grid: " + sprintf("%d",i/N_plot*100) + "% ...";
  end
  
  b.visible = "off";

  zm = min(z_data); zM = max(z_data);
  xset("colormap",jetcolormap(128))
  colorbar(zm,zM);
  
  Sgrayplot( x_axis, y_axis, z_data); 
  //a=gca();
  h=gce(); 
  
  
  
  //xgrid;
  xlabel(xlab);
  ylabel(ylab);
  zlabel(zlab);
  title(tit);

  a.grid=[1 1 1]; //make grids

  a.parent.background = -2;
   
  a.parent.color_map(130,:) = [0.95 0.9 1 ];
  a.parent.background = 130;
  a.title.font_size = 3;
  a.title.font_style=5;
  a.x_label.font_style = 6;
  a.x_label.font_size = 2;
  a.y_label.font_style = 6;
  a.y_label.font_size = 2;
  a.foreground = 2;

endfunction
