
function [] = montesci_waveplot(xdata, ydata, xlab, ylab, tit, valid_runs)
  scf;

  if (length(xdata)==0)
    for i=1:1:length(ydata)
      plot(ydata(i));
    end
    xlabel('vector index')
  else
    for i=1:1:length(ydata)
      plot(xdata(i), ydata(i));
    end
    xlabel(xlab);
  end
  
  a=gca();
  append_plot_to_list(a.parent);

  // colorize curves
  for i=1:1:length(ydata)
    a.children(i).children.foreground = modulo(i, 30);
  end

  xgrid;
  
  ylabel(ylab);
  title(tit)
  a.parent.background = -2;
  a.parent.color_map(33,:) = [0.95 1 0.9];
  a.parent.background = 33;
  a.children.children(1).thickness = 2;
  a.title.font_size = 3;
  a.title.font_style=5;
  a.x_label.font_style = 6;
  a.x_label.font_size = 2;
  a.y_label.font_style = 6;
  a.y_label.font_size = 2;
  a.foreground = 2;
  
    
  // plot nominal waveform
  if (length(xdata)==0)
      plot(ydata(1),"magenta");
      a.children.children(1).thickness = 3;
  else
      plot(xdata(1), ydata(1), "magenta");
      a.children.children(1).thickness = 3;
  end
   
endfunction
